
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InspectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.create(
            {
                id: data.id || undefined,
        
        inspection_number: data.inspection_number
        ||
        null
            ,
            
        inspection_type: data.inspection_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inspections.setInspection_plan( data.inspection_plan || null, {
            transaction,
        });
        
        await inspections.setMaterial( data.material || null, {
            transaction,
        });
        
        await inspections.setLot( data.lot || null, {
            transaction,
        });
        
        await inspections.setProduction_lot( data.production_lot || null, {
            transaction,
        });
        
        await inspections.setProduction_order( data.production_order || null, {
            transaction,
        });
        
        await inspections.setInspector( data.inspector || null, {
            transaction,
        });
        
        await inspections.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.inspections.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: inspections.id,
            },
            data.attachments,
            options,
        );
        

        return inspections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inspectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                inspection_number: item.inspection_number
            ||
            null
            ,
            
                inspection_type: item.inspection_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inspections = await db.inspections.bulkCreate(inspectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < inspections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.inspections.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: inspections[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return inspections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const inspections = await db.inspections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.inspection_number !== undefined) updatePayload.inspection_number = data.inspection_number;
        
        
        if (data.inspection_type !== undefined) updatePayload.inspection_type = data.inspection_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        updatePayload.updatedById = currentUser.id;

        await inspections.update(updatePayload, {transaction});

        
        
        if (data.inspection_plan !== undefined) {
            await inspections.setInspection_plan(
              
              data.inspection_plan,
              
              { transaction }
            );
        }
        
        if (data.material !== undefined) {
            await inspections.setMaterial(
              
              data.material,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await inspections.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.production_lot !== undefined) {
            await inspections.setProduction_lot(
              
              data.production_lot,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await inspections.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        
        if (data.inspector !== undefined) {
            await inspections.setInspector(
              
              data.inspector,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await inspections.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.inspections.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: inspections.id,
            },
            data.attachments,
            options,
        );
        

        return inspections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inspections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inspections) {
                await record.destroy({transaction});
            }
        });


        return inspections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.findByPk(id, options);

        await inspections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inspections.destroy({
            transaction
        });

        return inspections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.findOne(
            { where },
            { transaction },
        );

        if (!inspections) {
            return inspections;
        }

        const output = inspections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inspection_results_inspection = await inspections.getInspection_results_inspection({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.inspection_plan = await inspections.getInspection_plan({
            transaction
        });
        
        
        output.material = await inspections.getMaterial({
            transaction
        });
        
        
        output.lot = await inspections.getLot({
            transaction
        });
        
        
        output.production_lot = await inspections.getProduction_lot({
            transaction
        });
        
        
        output.production_order = await inspections.getProduction_order({
            transaction
        });
        
        
        output.inspector = await inspections.getInspector({
            transaction
        });
        
        
        output.attachments = await inspections.getAttachments({
            transaction
        });
        
        
        output.organizations = await inspections.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.inspection_plans,
        as: 'inspection_plan',
        
        where: filter.inspection_plan ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspection_plan.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.inspection_plan.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.materials,
        as: 'material',
        
        where: filter.material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_lots,
        as: 'production_lot',
        
        where: filter.production_lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.production_lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'inspector',
        
        where: filter.inspector ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspector.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.inspector.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.inspection_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inspections',
                        'inspection_number',
                        filter.inspection_number,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inspections',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            

            
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.inspection_type) {
                where = {
                    ...where,
                inspection_type: filter.inspection_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inspections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inspections',
                        'inspection_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inspections.findAll({
            attributes: [ 'id', 'inspection_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['inspection_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.inspection_number,
        }));
    }

    
};

